
* Results
  
** Details
Figures in the following have a grid layout were :
 - the rows represents the blas library used
 - the columns represents the solver (and their variations) used.

Matrix used
https://math.nist.gov/MatrixMarket/data/Harwell-Boeing/bcsstruc3/bcsstm23.html
(symmetric real matrix)

Tolerance used $10^{-8}$

*** Solver list
=Fabulous= library is called thought =maphys++='s interface.
   
- =GCR= (m++) ($\infty$) : =maphys++= GCR with no restart
- =BGCR= ($\infty$) : Fabulous BGCR with no restart
- =BGCR= ($100$) : Fabulous BGCR with restart after $100$ iterations
- =BGMRES= ($\infty$) : Fabulous BGMRES with no restart
- =BGMRES= ($100$) : Fabulous BGMRES with restart after $100$ iterations
- =IB-BGMRES-DR= ($\infty$) : Fabulous BGMRES with inexact breakdown and no restart
- =IB-BGMRES-DR= ($100$) : Fabulous BGMRES with inexact breakdown and deflationate restart after $100$ iterations

   
** Simple right-hand-side (nrhs = 1)

*** Iteration
#+caption: Normalised residual behaviour over the iterations for nrhs = 1
file:./img/cvg_iter.png

*** Time
#+caption: Normalised residual behaviour over time for nrhs = 1
file:./img/cvg_time.png

*** On two consecutive vectors
#+caption: Time and iteration for solving two right-hand-side (nrhs = 1)
file:./img/results.png


** Multiple right-hand-side (nrhs = 20)

*** Iteration
#+caption: Normalised residual behaviour over the iterations for nrhs = 20
file:./img/cvg_iter_20.png

*** Time
#+caption: Normalised residual behaviour over time for nrhs = 20
file:./img/cvg_time_20.png

*** On two consecutive blocks
#+caption: Time and iteration for solving two right-hand-side (nrhs = 20)
file:./img/results20.png

* Code
** Header
#+begin_src cpp :tangle ../../src/examples/fabulous_bench.cpp
  #ifdef MPH_USE_RSB_SPBLAS
  #include <rsb.h>         
  #include <blas_sparse.h> 
  #endif

  #include <fstream>
  #include <iostream>
  #include <vector>
  #include <stdlib.h>

  #define FABULOUS_USE_SHARED_TIMER_CPP
  #define TIMER_LEVEL_MAX 101
  #define TIMER_LEVEL_MIN 0

  //#include <fabulous.hpp>

  #include <maphys.hpp>
  #include <maphys/solver/Fabulous.hpp>
  #include <maphys/solver/GCR.hpp>
  #include <maphys/solver/ConjugateGradient.hpp>
  #include <maphys/IO/ReadParam.hpp>
  #include <maphys/loc_data/SparseMatrixCOO.hpp>
  #include <maphys/testing/TestMatrix.hpp>
  #include <maphys/testing/catch.hpp>

  #include <maphys/precond/Dummy.hpp>
  #include <maphys/precond/TruncateColumns.hpp>
  #include <maphys/precond/DiagonalPrecond.hpp>
  #include <maphys/solver/CastOperator.hpp>
  #include <maphys/solver/Pastix.hpp>
  // #include <maphys/solver/Mumps.hpp>
#+end_src
** Useful macro
#+begin_src cpp :tangle ../../src/examples/fabulous_bench.cpp

     #ifndef MPH_USE_SHARED_TIMER
     #include "Timer.hpp"
     #else
     #include "Timer_api.hpp"
     #endif

     const std::string blas_name =
     #if defined MPH_USE_RSB_SPBLAS

     #if defined MPH_USE_MKL
	 "mkl/rsb";
     #else
	 "openblas/rsb";
     #endif

     #else // No RSB

     #if defined MPH_USE_MKL_SPBLAS
	 "mkl/mkl";
     #else
	 "openblas/m++";
     #endif

     #endif


     using namespace maphys;



     #define FAB_BENCH(SOLVER_NAME, SETUP, K, ...) {                                                \
			      Timer<0> t_setup("Setup");                                            \
			      __VA_ARGS__ fab;                                                      \
			      SETUP (K)                                                             \
			      t_setup.stop();                                                       \
			      const double setup = Timer<0>::get_event_cumul_time("Setup");         \
			      multi_run< __VA_ARGS__ >(fab, A, X, B, setup, SOLVER_NAME, NB_FAMILY, bench, ortho_type); \
			      n_iter = fab.get_n_iter();                                            \
			     }



     #define FAB_SETUP(X) fab.setup(fabulous_params::A<SparseMatrixCOO<Scalar>>{A},		       \
				      fabulous_params::tolerances<std::vector<Real>>{tol},          \
				      fabulous_params::max_iter<int>{max_iter},                     \
				      fabulous_params::max_krylov_space<int>{X},                    \
				      fabulous_params::ortho_type{fabulous::OrthoType::ORTHO_METHOD},      \
				      fabulous_params::ortho_scheme{ortho_type},                    \
				      fabulous_params::verbose<bool>{verbose});

     #define FAB_SETUP_GCRO(X) fab.setup(fabulous_params::A<SparseMatrixCOO<Scalar>>{A}, \
				      fabulous_params::tolerances<std::vector<Real>>{tol},          \
				      fabulous_params::max_iter<int>{max_iter},                     \
				      fabulous_params::max_krylov_space<int>{X},                    \
				      fabulous_params::ortho_type{fabulous::OrthoType::ORTHO_METHOD},      \
				      fabulous_params::ortho_scheme{ortho_type},                    \
				      fabulous_params::verbose<bool>{verbose});
				      //fabulous_params::Uk{Uk});

     #define FAB_SETUP_DR(X) fab.setup(fabulous_params::A<SparseMatrixCOO<Scalar>>{A},	       \
				      fabulous_params::tolerances<std::vector<Real>>{tol},          \
				      fabulous_params::max_iter<int>{max_iter},                     \
				      fabulous_params::max_krylov_space<int>{X},                    \
				      fabulous_params::ortho_type{fabulous::OrthoType::ORTHO_METHOD},      \
				      fabulous_params::ortho_scheme{ortho_type},                    \
				      fabulous_params::verbose<bool>{verbose},                      \
				      fabulous_params::deflated_restart{fabulous::deflated_restart<Scalar>(k, Scalar{0})});

     #define FAB_SETUP_GCRO_DR(X) fab.setup(fabulous_params::A<SparseMatrixCOO<Scalar>>{A},	       \
				      fabulous_params::tolerances<std::vector<Real>>{tol},          \
				      fabulous_params::max_iter<int>{max_iter},                     \
				      fabulous_params::max_krylov_space<int>{X},                    \
				      fabulous_params::ortho_type{fabulous::OrthoType::ORTHO_METHOD},      \
				      fabulous_params::ortho_scheme{ortho_type},                    \
				      fabulous_params::verbose<bool>{verbose},                      \
				      fabulous_params::deflated_restart{fabulous::deflated_restart<Scalar>(k, Scalar{0})});
     //#define ORTHO_METHOD BLOCK
     #define ORTHO_METHOD RUHE
     #define NB_FAMILY 10
     #define TAG(SOLVER_NAME) blas_name + ',' + type_to_str<Scalar>() + ',' + SOLVER_NAME + ",MGS," \
                              + std::to_string(i) + ','+ std::to_string(fab.get_n_iter()) + ','
#+end_src
** Type to string
#+begin_src cpp :tangle ../../src/examples/fabulous_bench.cpp

   int trace = 0;

   template<typename Scalar>
   const std::string type_to_str(void){
     static const std::string name[4] = {"real (simple)", "real (double)", "complex (simple)", "complex (double)"};
     if constexpr(std::is_same_v<Scalar, float>){
       return name[0];
     } else if constexpr(std::is_same_v<Scalar, double>){
       return name[1];
     } else if(std::is_same_v<Scalar, std::complex<float>>){
       return name[2];
     } else if(std::is_same_v<Scalar, std::complex<double>>){
       return name[3];
     }
   }
#+end_src
** Display fonctions
#+begin_src cpp :tangle ../../src/examples/fabulous_bench.cpp

   template<typename Scalar>
   void display(const std::string name, const int n, const int n_iter,
		const SparseMatrixCOO<Scalar> &A, const DenseMatrix<Scalar> &B1,
		const DenseMatrix<Scalar> &X1_exp, const DenseMatrix<Scalar> &X1,
		const double t_setup, const int bench,
		const fabulous::OrthoScheme ortho_type) {

     const double X1_norm = X1_exp.frobenius_norm();
     const double rr = (A * X1 - B1).frobenius_norm() / B1.frobenius_norm();
     const double t_solve = Timer<0>::get_event_cumul_time("Solve");
     std::string o_str = "MGS";
     if(ortho_type == fabulous::OrthoScheme::CGS) o_str = "CGS";

     if(bench == 1 && !trace) {
       std::cout << blas_name << "," << name << "," << o_str << "," << n << "," << n_iter << ",";
       std::cout << t_setup << "," << t_solve << "," << (X1_exp - X1).frobenius_norm() / X1_norm;
       std::cout << "," << type_to_str<Scalar>() << ',' << rr << ',' << B1.get_nb_col() << '\n';
     } else if(bench == 0 && !trace) {
       std::cout <<  "[using" << blas_name << "]\n";
       std::cout << type_to_str<Scalar>() << "\n";
       std::cout << name  << " + " << o_str << "\n";
       std::cout << "iterations : " << n_iter << "\n";
       std::cout << "Setup time : " << t_setup << "\n";
       std::cout << "Solve time : " << t_solve << "\n";
       std::cout << "||X_exp - X||_F / ||X_exp||_F = " << (X1_exp - X1).frobenius_norm() / X1_norm << "\n";
       std::cout << "||AX - B||_F / ||B||_F = " << rr << "\n";
       std::cout << "nrhs = " << B1.get_nb_col() << "\n";
     }
   }


   template<typename Scalar>
   void print_cvg_fabulous(fabulous::Logger& log, const std::string name, const int n, const fabulous::OrthoScheme ortho_type, const int nrhs){
    std::string o_str = "MGS";
    if(ortho_type == fabulous::OrthoScheme::CGS) o_str = "CGS";
    std::string blas_name_n =  blas_name + ',' + type_to_str<Scalar>() + ',' + name + ',' + o_str + ',' + std::to_string(n) + ',' + std::to_string(nrhs) + ',';

     const double* data = log.write_down_array();
     double time_from_start = 0.0;
     auto iter = log.get_iterations();
     //std::cerr << log.get_nb_iterations() << '\n';
     for (int i = 0; i < log.get_nb_iterations(); ++i) {
       time_from_start += data[3*i + 2];
       std::cout << blas_name_n << iter[i].nb_mvp << "," << data[3*i + 0] << "," << data[3*i + 1] << "," << time_from_start << "\n";
     }

   }

   std::vector<double> norm_list;
   std::vector<double> time_list;

   template<typename Scalar>
   void print_norm_list(const std::string name, const int n){
     std::string blas_name_n =  blas_name + ',' + type_to_str<Scalar>() + ',' + name + ",MGS," + std::to_string(n) + ',';

     for(int i = 0; i < norm_list.size(); i++){
       std::cout << blas_name_n << i << ',' << norm_list[i] << ',' << norm_list[i] << ',' << time_list[i] << '\n';
     }
   }


#+end_src
** Solve blocks of right-hand-sides
#+begin_src cpp :tangle ../../src/examples/fabulous_bench.cpp


  template<class FSolver, typename Scalar>
  void run(FSolver& fab, const SparseMatrixCOO<Scalar> &A,
	   const DenseMatrix<Scalar> &X1_exp,
	   const DenseMatrix<Scalar> &B1, const double t_setup,
	   const std::string name, const int n, const int bench,
	   const fabulous::OrthoScheme ortho_type){

    Timer<0> t_solve("Solve");
    const DenseMatrix<Scalar> X1 = fab * B1;
    t_solve.stop();

    if (bench == 2 && !trace) {
      if constexpr (std::is_same<FSolver, GCR<SparseMatrixCOO<Scalar>, maphys::Vector<Scalar>>>::value ||
		    std::is_same<FSolver, ConjugateGradient<SparseMatrixCOO<Scalar>, maphys::Vector<Scalar>>>::value){
	print_norm_list<Scalar>(name, n);
      } else {
	fabulous::Logger log = fab.get_last_log();
	print_cvg_fabulous<Scalar>(log, name, n, ortho_type, B1.get_nb_col());
      }
    } else {
      display(name, n, fab.get_n_iter(), A, B1, X1_exp, X1, t_setup, bench, ortho_type);
    }
    Timer<0>::reset();

    norm_list.clear();
    time_list.clear();
  }


  template<class FSolver, typename Scalar>
  void multi_run(FSolver& fab, const SparseMatrixCOO<Scalar> &A,
	   const std::vector<DenseMatrix<Scalar>> &X,
	   const std::vector<DenseMatrix<Scalar>> &B, const double t_setup,
	   const std::string name, const int n_max, const int bench,
	   const fabulous::OrthoScheme ortho_type){

    for(int i = 0; i < n_max; i++) {
      run(fab, A, X[i], B[i], t_setup, name, i, bench, ortho_type);
      if(trace) std::cout << (TAG(name)) << '\n';
    }
  }
#+end_src
** Maphys++ callback
#+begin_src cpp :tangle ../../src/examples/fabulous_bench.cpp

   template<typename Scalar>
   void callback(const SparseMatrixCOO<Scalar>& A, const maphys::Vector<Scalar>& B, const maphys::Vector<Scalar>& X, const maphys::Vector<Scalar>& R){

     static double B_norm = B.norm();
     static int iter = 0;

     // reset for a new run
     if(time_list.size() != iter){
       iter = 0;
       B_norm = B.norm();
     }

     norm_list.push_back(R.norm() / B_norm);
     if(iter++ == 0){ // First iteration
       time_list.push_back(Timer<0>::get_event_cumul_time("GCR iteration 0"));
     }else{
       time_list.push_back(Timer<0>::get_event_cumul_time("GCR iteration"));
     }

   }


#+end_src
** Experiment definition (solvers & parameters)
#+begin_src cpp :tangle ../../src/examples/fabulous_bench.cpp

     template<typename Scalar, typename Scalar2 = float>
     void experiments(const std::string path_A, int n, int bench, int is_sym, const fabulous::OrthoScheme ortho_type){
       using Real = typename arithmetic_real<Scalar>::type;

       SparseMatrixCOO<Scalar> A;
       A.from_matrix_market_file(path_A);

       //std::cerr << A.properties_str() << "\n";
       if(is_sym) A.fill_tri_to_full();

       const Real tol_0 = 1.0e-8;
       const std::vector<Real> tol{tol_0};
       const bool verbose = !true;
       /*const*/ int restart_iter = 250; 
       const int m = A.get_nb_row(), nnz_max = m * n;
       const Real max = 10000.0;
       const int max_iter = 2000;
       const int max_krylow_space = restart_iter;//1000;
       const int k = 50; // Defletion space's size
       /*
       SparseMatrixCOO<Scalar> Xf;
       Xf.from_matrix_market_file("../matrices/rhs_bad.mtx");
       const DenseMatrix<Scalar> X1_exp = Xf.to_dense();// = test_matrix::random_matrix<Scalar, DenseMatrix<Scalar>>(nnz_max, -max, max, m, n).matrix;
       //*/
       std::vector<DenseMatrix<Scalar>> X;
       std::vector<DenseMatrix<Scalar>> B;
       for(int i = 0; i < NB_FAMILY; i++){
	 //const std::string name = "/home/matthieu/Repositories/maphyspp/matrices/RHS/sol2_" + std::to_string(i) + ".mtx_tmp";
	 //SparseMatrixCOO<Scalar> Xi1;// = test_matrix::random_matrix<Scalar, SparseMatrixCOO<Scalar>>(nnz_max, -max, max, m, n).matrix;
	 //Xi1.from_matrix_market_file(name);
	 //Xi1.display();
	 //std::cout << m << ' ' << n << ' ' << Xi1.get_nnz() << '\n';
	 //std::cout << "%%MatrixMarket matrix coordinate complex general" << '\n';
	 //Xi1.correct_plus_1();
	 DenseMatrix<Scalar> Xi = test_matrix::random_matrix<Scalar, DenseMatrix<Scalar>>(nnz_max, -max, max, m, n).matrix;
	 //Xi1.convert(Xi);
	 X.push_back(Xi);
	 B.push_back(A * Xi);
       }

       int n_iter = -1;
       using SpMat = SparseMatrixCOO<Scalar>;
       using DMat = DenseMatrix<Scalar>;

       using Pastix32 = Pastix<SparseMatrixCOO<Scalar2>, DenseMatrix<Scalar2>>;
       using Pastix64 = Pastix<SparseMatrixCOO<Scalar>, DenseMatrix<Scalar>>;
       //using DirSolver = Mumps<SparseMatrixCOO<Scalar2>, DenseMatrix<Scalar2>>;
       //using DirSolver = DiagonalPrecond<SparseMatrixCOO<Scalar2>, DenseMatrix<Scalar2>>;
       using CO = CastOperator<SpMat, DMat, Pastix32>;
       //using Precond = NoPrecond;
       //using Precond = DummyPrecond<SpMat, DMat, NoPrecond>;
       //using Precond = DiagonalPrecond<SpMat, DMat>;
       //using Precond = DummyPrecond<SpMat, DMat, CO>;
       using Precond = TruncateColumns<SpMat, DMat, Pastix64, 9, 10>;
       //using Precond = TruncateColumns<SpMat, DMat, 1, 3, DummyPrecond<SpMat, DMat, CO>>;
       //using Precond = Pastix64;                                                                                 

       // Test for k = 0
       //FAB_BENCH("IB-BGCRO (\u221E) k = 0", FAB_SETUP, max_iter, Fabulous<SpMat, DMat, Precond, fabulous::bgcro::ARNOLDI>)
       //FAB_BENCH("IB-BGCRO (\u221E) k = " + std::to_string(k), FAB_SETUP_GCRO, max_iter, Fabulous<SpMat, DMat, Precond, fabulous::bgcro::ARNOLDI>)
       //FAB_BENCH("IB-BGMRES (\u221E)", FAB_SETUP, max_iter, Fabulous<SpMat, DMat, Precond, fabulous::bgmres::ARNOLDI_IB>)

       // Test for k > 0
       //FAB_BENCH("IB-BGCRO (" + std::to_string(restart_iter) + ") k = 0", FAB_SETUP, restart_iter, Fabulous<SpMat, DMat, Precond, fabulous::bgcro::ARNOLDI>)
       //FAB_BENCH("IB-BGCRO (" + std::to_string(restart_iter) + ") k = " + std::to_string(k), FAB_SETUP_GCRO, restart_iter, Fabulous<SpMat, DMat, Precond, fabulous::bgcro::ARNOLDI>)
       //FAB_BENCH("IB-BGMRES (" + std::to_string(restart_iter) + ")", FAB_SETUP, restart_iter, Fabulous<SpMat, DMat, Precond, fabulous::bgmres::ARNOLDI_IB>)


       //FAB_BENCH("IB-BGMRES-DR (" + std::to_string(restart_iter) + ") k = " + std::to_string(k), FAB_SETUP_DR, restart_iter, Fabulous<SpMat, DMat, Precond, fabulous::bgmres::ARNOLDI_IBDR, fabulous::DeflatedRestart<Scalar>>)
       restart_iter -= k;
       //FAB_BENCH("IB-BGCRO-DR (" + std::to_string(restart_iter) + ") k = " + std::to_string(k), FAB_SETUP_GCRO_DR, restart_iter, Fabulous<SpMat, DMat, Precond, fabulous::bgcro::ARNOLDI, fabulous::DeflatedRestart<Scalar>>)


       //FAB_BENCH("IB-BGCR (\u221E)", FAB_SETUP, max_iter, Fabulous<SpMat, DMat, Precond, fabulous::bgcr::ARNOLDI>)
       //FAB_BENCH("IB-BGCR (" + std::to_string(restart_iter) + ")", FAB_SETUP, max_krylow_space, Fabulous<SpMat, DMat, Precond, fabulous::bgcr::ARNOLDI>)

       //FAB_BENCH("BGMRES (\u221E)", FAB_SETUP, max_iter, Fabulous<SpMat, DMat>)
       //FAB_BENCH("BGMRES (" + std::to_string(restart_iter) + ")", FAB_SETUP, max_krylow_space, Fabulous<SpMat, DMat, Precond>)

    FAB_BENCH("IB-BGMRES-DR (\u221E)", FAB_SETUP_DR, max_iter, Fabulous<SpMat, DMat, Precond,fabulous::bgmres::ARNOLDI_IBDR, fabulous::DeflatedRestart<Scalar>>)


  }

#+end_src
** main() 
#+begin_src cpp :tangle ../../src/examples/fabulous_bench.cpp


   int main(int argc, char ** argv) {
     MMPI::init();
  #ifdef MPH_USE_RSB_SPBLAS
     if(rsb_lib_init(RSB_NULL_INIT_OPTIONS) != RSB_ERR_NO_ERROR){
       std::cerr << "Not able to start librsb\n";
       MMPI::finalize();
       return -1;
     }
   #endif
     //std::ofstream outfile;
     //outfile.open("trace.csv");
     //Timer<0>::set_trace_output(&outfile);

     std::string path_A = "";
     int n = 0;
     int bench = 0;
     int is_sym = 0;
     auto ortho_type = fabulous::OrthoScheme::MGS;
     try{
       // name of file of matrix A
       path_A = argv[1];
       // number of columns of B1
       n = atoi(argv[2]);
       // bench type
       const std::string s(argv[3]);
       bench = (s == "-b") + (s == "-p")*2 + (s == "-ps")*2;
       is_sym = (s == "-ps") + (s == "-s");
       trace = (s == "-t");
       // Orthogonalisation process
       if(argc > 4){
	 const std::string ortho_string(argv[4]);
	 if(ortho_string == "-CGS") ortho_type = fabulous::OrthoScheme::CGS;
       }
     }
     catch(const std::out_of_range& e){
       std::cerr << "invalid usage\n";
       return 0;
     }
   #ifdef MPH_USE_SHARED_TIMER
     Timer<0>::set_trace(trace);
   #endif
     std::cout.precision(3);
     std::cout << std::scientific;
   //  std::cerr.precision(3);
   //  std::cerr << std::scientific;

     srand(1);

     if(matrix_market::is_real_matrix(path_A)){
       experiments<double>(path_A, n, bench, is_sym, ortho_type);
     } else {
       experiments<std::complex<double>, std::complex<float>>(path_A, n, bench, is_sym, ortho_type);
     }


   //*/
     //outfile.close();
   #ifdef MPH_USE_RSB_SPBLAS
     if(rsb_lib_exit(RSB_NULL_EXIT_OPTIONS) != RSB_ERR_NO_ERROR){
       std::cerr << "Not able to exit librsb\n";
       MMPI::finalize();
       return -1;
     }
   #endif
     MMPI::finalize();
     return 0;
   }


#+end_src

* Compiling and testing
** openblas
#+begin_src sh

guix environment --pure maphys++ --ad-hoc slurm eigen armadillo scalapack zlib fabulous -- cmake .. -DCMAKE_BUILD_TYPE=Release -DMAPHYS_COMPILE_EXAMPLES=ON -DMAPHYS_COMPILE_TESTS=OFF -DMAPHYS_DEV_TANGLE=OFF -DMAPHYS_GCC_WARNINGS=OFF -DMAPHYS_USE_FABULOUS=ON && \
guix environment --pure maphys++ --ad-hoc slurm eigen armadillo scalapack zlib fabulous -- make test_fabulous_B1 && \
guix environment --pure maphys++ --ad-hoc slurm eigen armadillo scalapack zlib fabulous -- ./src/examples/test_fabulous_B1 ../matrices/bcsstk09.mtx 50

#+end_src

Output :
#+begin_src sh

#+end_src

** mkl
#+begin_src sh

guix environment --pure maphys++ --with-input=mumps-openmpi=mumps-mkl-openmpi --with-input=openblas=mkl --ad-hoc slurm eigen armadillo scalapack zlib fabulous -- cmake .. -DCMAKE_BUILD_TYPE=Release -DMAPHYS_COMPILE_EXAMPLES=ON -DMAPHYS_COMPILE_TESTS=OFF -DMAPHYS_DEV_TANGLE=OFF -DMAPHYS_GCC_WARNINGS=OFF -DMAPHYS_USE_FABULOUS=ON && \
guix environment --with-input=mumps-openmpi=mumps-mkl-openmpi --with-input=openblas=mkl  --pure maphys++ --ad-hoc slurm eigen armadillo scalapack zlib fabulous -- make test_fabulous_B1 && \
guix environment --pure maphys++ --with-input=mumps-openmpi=mumps-mkl-openmpi --with-input=openblas=mkl --ad-hoc slurm eigen armadillo scalapack zlib fabulous -- ./src/examples/test_fabulous_B1 ../matrices/bcsstk09.mtx 50

#+end_src


Output :
#+begin_src sh

#+end_src

* Bench
** Generation
#csplit --digits=1 --quiet --prefix=outfile trace.csv "/mk/+1" "{*}"
#for i in $(seq 0 6); do head -n -1 outfile$i | sed "s@^@$(tail -n 1 outfile$i)@" >> ../traces/trace_all_test.csv ; done   
#+begin_src sh :tangle bench_fabulous.sh
NRHS=20; \  # Number of columns of right hand side
MATRIX_PATH_REAL=../matrices/bcsstk17.mtx; \  # Input matrix (A in Ax = b)
MATRIX_PATH_CPX=../matrices/young1c.mtx; \  # Input matrix (A in Ax = b)
GUIX_BASE_ENV=' -L /home/matthieu/Repositories/guix-hpc --pure maphys++ --ad-hoc eigen armadillo scalapack zlib fabulous '; \
GUIX_BASE_ENV=${GUIX_BASE_ENV}' --with-source=fabulous=fabulous+timer '
CMAKE_BASE_FLAGS=' -DCMAKE_BUILD_TYPE=Release -DMAPHYS_COMPILE_EXAMPLES=ON -DMAPHYS_COMPILE_TESTS=OFF '; \
CMAKE_BASE_FLAGS=${CMAKE_BASE_FLAGS}' -DMAPHYS_DEV_TANGLE=OFF -DMAPHYS_GCC_WARNINGS=OFF -DMAPHYS_USE_FABULOUS=ON -DMAPHYS_USE_SHARED_TIMER=ON '; \ 
GUIX_MKL_ENV=' --with-input=mumps-openmpi=mumps-mkl-openmpi --with-input=openblas=mkl '; \
GUIX_RSB_ENV=' librsb --with-source=librsb=/home/matthieu/Repositories/librsb '; \
CMAKE_RSB_FLAGS=' -DMAPHYS_USE_RSB_SPBLAS=ON'; \
EXE='./src/examples/test_fabulous_B1'; \
mkdir -p ../csv && \
OUT1=../csv/results_summary.csv; \
OUT2=../csv/results_iter.csv; \
bench(){
guix environment $GUIX_ENV -- cmake .. $CMAKE_FLAGS && \
guix environment $GUIX_ENV -- make test_fabulous_B1 && \
#guix environment $GUIX_ENV -- $EXE $MATRIX_PATH_REAL $NRHS -b      >> $OUT1 && \
#guix environment $GUIX_ENV -- $EXE $MATRIX_PATH_REAL $NRHS -p      >> $OUT2 && \
guix environment $GUIX_ENV -- $EXE $MATRIX_PATH_CPX  $NRHS -b      >> $OUT1 && \
guix environment $GUIX_ENV -- $EXE $MATRIX_PATH_CPX  $NRHS -p      >> $OUT2 && \
#guix environment $GUIX_ENV -- $EXE $MATRIX_PATH_REAL $NRHS -b -CGS >> $OUT1 && \
#guix environment $GUIX_ENV -- $EXE $MATRIX_PATH_REAL $NRHS -p -CGS >> $OUT2 && \
#guix environment $GUIX_ENV -- $EXE $MATRIX_PATH_CPX  $NRHS -b -CGS >> $OUT1 && \
#guix environment $GUIX_ENV -- $EXE $MATRIX_PATH_CPX  $NRHS -p -CGS >> $OUT2 
}
echo 'blas,solver,ortho,position,n_iter,t_setup,t_solve,re,scalar,rr,nrhs' > $OUT1 && \
echo 'blas,scalar,solver,ortho,n,nrhs,iter,min,max,time' > $OUT2 && \
GUIX_ENV=$GUIX_BASE_ENV ; \
CMAKE_FLAGS=$CMAKE_BASE_FLAGS ; \
bench  && \
rm -rf * && \
GUIX_ENV=${GUIX_MKL_ENV}$GUIX_BASE_ENV ; \
bench  && \
rm -rf * && \
GUIX_ENV=${GUIX_BASE_ENV}$GUIX_RSB_ENV ; \
CMAKE_FLAGS=${CMAKE_BASE_FLAGS}$CMAKE_RSB_FLAGS ; \
bench  && \
rm -rf * && \
GUIX_ENV=${GUIX_MKL_ENV}${GUIX_BASE_ENV}$GUIX_RSB_ENV ; \
bench  && \
cp ../csv/*.csv . && \
guix environment --pure --ad-hoc coreutils bash r-minimal r-stringr r-dplyr r-ggplotify r-tidyr sed -- R CMD BATCH ../src/examples/test_fabulous_bar.R && \
guix environment --pure --ad-hoc coreutils bash r-minimal r-stringr r-dplyr r-ggplotify r-tidyr sed -- R CMD BATCH ../src/examples/test_fabulous_cvg.R && \
mkdir -p ../img && \
cp *.png ../img

#+end_src
** Variable numbre of right-hand-side
#+begin_src sh :tangle bench_fabulous_nrhs.sh
MIN_NRHS=1
MAX_NRHS=20; \  # Number of columns of right hand side
MATRIX_PATH=../matrices/young1c.mtx; \  # Input matrix (A in Ax = b)
GUIX_BASE_ENV='-L /home/matthieu/Repositories/guix-hpc --pure maphys++ --ad-hoc eigen armadillo scalapack zlib fabulous --preserve=^OMP_NUM_THREADS'; \
CMAKE_BASE_FLAGS=' -DCMAKE_BUILD_TYPE=Release -DMAPHYS_COMPILE_EXAMPLES=ON -DMAPHYS_COMPILE_TESTS=OFF'; \
CMAKE_BASE_FLAGS=${CMAKE_BASE_FLAGS}' -DMAPHYS_DEV_TANGLE=OFF -DMAPHYS_GCC_WARNINGS=OFF -DMAPHYS_USE_FABULOUS=ON'; \ 
GUIX_MKL_ENV=' --with-input=mumps-openmpi=mumps-mkl-openmpi --with-input=openblas=mkl '; \
GUIX_RSB_ENV='librsb --with-source=librsb=/home/matthieu/Repositories/librsb'; \
CMAKE_RSB_FLAGS=' -DMAPHYS_USE_RSB_SPBLAS=ON'; \
EXE=./src/examples/test_fabulous_B1; \
mkdir -p ../traces && \
PREFIX=../traces/traces_ ; \
guix environment $GUIX_ENV -- cmake .. $CMAKE_FLAGS && \
guix environment $GUIX_ENV -- make test_fabulous_B1 && \
trace(){
 for nrhs in $(seq ${MIN_NRHS} ${MAX_NRHS}); do export OMP_NUM_THREADS=1 && $EXE $MATRIX_PATH $nrhs -t && mv trace.csv ${PREFIX}${nrhs}.csv ; done
}
guix environment $GUIX_ENV -- ../trace.sh

#+end_src
** Bar recap
    -DMAPHYSPP_USE_SHARED_TIMER=ON
#+begin_src sh :tangle bench_fabulous_bar.sh
  MIN_NRHS=25; \
  MAX_NRHS=25; \  # Number of columns of right hand side
  MATRIX_PATH=/home/matthieu/Repositories/maphyspp/matrices/young1c.mtx; \  #/home/msimonin/pc/maphyspp/matrices/matrix_PW_PBC_PML_P1.mtx; \  # Input matrix (A in Ax = b)
  GUIX_BASE_ENV='-L /home/matthieu/Repositories/guix-hpc --pure maphys++ --ad-hoc eigen armadillo scalapack zlib fabulous+timer'; \
  GUIX_BASE_ENV=${GUIX_BASE_ENV}" --preserve='^OMP_NUM_THREADS$' "; \
  CMAKE_BASE_FLAGS=' -DCMAKE_BUILD_TYPE=Release -DMAPHYSPP_COMPILE_EXAMPLES=ON -DMAPHYSPP_COMPILE_TESTS=OFF'; \
  CMAKE_BASE_FLAGS=${CMAKE_BASE_FLAGS}' -DMAPHYSPP_DEV_TANGLE=OFF -DMAPHYSPP_GCC_WARNINGS=OFF -DMAPHYSPP_USE_FABULOUS=ON '; \ 
  CMAKE_BASE_FLAGS=${CMAKE_BASE_FLAGS}' -DTIMER_DIR=/gnu/store/76qdyqdlbnv66zv5f4kxs1xkqlmwl6py-timer-cpp-0.1.0/'; \
  GUIX_MKL_ENV=' --with-input=mumps-openmpi=mumps-mkl-openmpi --with-input=openblas=mkl '; \
  GUIX_RSB_ENV=' librsb --with-source=librsb=/home/matthieu/Repositories/librsb '; \
  CMAKE_RSB_FLAGS=' -DMAPHYS_USE_RSB_SPBLAS=ON'; \
  rm -f ../trace_t.csv && \
  rm -f ../trace_p.csv && \
  rm -f ../trace_b.csv && \
  export OMP_NUM_THREADS=1 ; \
  trace(){
  guix environment $GUIX_ENV -- cmake .. $CMAKE_FLAGS && \
  guix environment $GUIX_ENV -- make test_fabulous_B1 && \
  for nrhs in $(seq ${MIN_NRHS} ${MAX_NRHS}); do export OMP_NUM_THREADS=1 && guix environment $GUIX_ENV --preserve='^OMP_NUM_THREADS$' -- ./src/examples/test_fabulous_B1 $MATRIX_PATH $nrhs -t >> ../trace_t.csv ; done
  for nrhs in $(seq ${MIN_NRHS} ${MAX_NRHS}); do export OMP_NUM_THREADS=1 && guix environment $GUIX_ENV --preserve='^OMP_NUM_THREADS$' -- ./src/examples/test_fabulous_B1 $MATRIX_PATH $nrhs -p >> ../trace_p.csv ; done
  for nrhs in $(seq ${MIN_NRHS} ${MAX_NRHS}); do export OMP_NUM_THREADS=1 && guix environment $GUIX_ENV --preserve='^OMP_NUM_THREADS$' -- ./src/examples/test_fabulous_B1 $MATRIX_PATH $nrhs -b >> ../trace_b.csv ; done
  }

  trace_reset(){
  rm -f ../trace_t.csv && \
  rm -f ../trace_p.csv && \
  rm -f ../trace_b.csv && \
  rm -rf *
  }

  GUIX_ENV=$GUIX_BASE_ENV ; \
  CMAKE_FLAGS=$CMAKE_BASE_FLAGS ; \
  rm -rf * && \
  trace  && \
  GUIX_ENV=${GUIX_BASE_ENV}$GUIX_RSB_ENV ; \
  CMAKE_FLAGS=${CMAKE_BASE_FLAGS}$CMAKE_RSB_FLAGS ; \
  rm -rf * && \
  trace  && \


  GUIX_ENV=${GUIX_MKL_ENV}${GUIX_BASE_ENV} ; \
  CMAKE_FLAGS=$CMAKE_BASE_FLAGS ; \
  rm -rf * && \
  trace  && \

  GUIX_ENV=${GUIX_MKL_ENV}${GUIX_BASE_ENV}$GUIX_RSB_ENV ; \
  CMAKE_FLAGS=${CMAKE_BASE_FLAGS}$CMAKE_RSB_FLAGS ; \
  rm -rf * && \
  trace  && \

  csplit --digits=2 --quiet --prefix=outfile ../trace_t.csv "/op/+1" "{*}" && \
  for f in $(ls outfile*); do head -n -1 $f | sed "s@^@$(tail -n 1 $f)@" >> trace_t.csv ; done && \
  csplit --digits=2 --quiet --prefix=outfile ../trace.csv "/mk/+1" "{*}" && \
  for f in $(ls outfile*); do head -n -1 $f | sed "s@^@$(tail -n 1 $f)@" >> trace_t.csv ; done && \
  cp trace_t.csv ..

#+end_src

** Post-treatment
*** Bar plot (detailed)
#+begin_src R :tangle test_fabulous_bar_color.R
library(ggplot2)
library(dplyr)
library(plyr)
library(tidyr)
library(stringr)


bar_color_data = function(data, target_level=1){


# saving values
blas = unique(data$blas)
solver = unique(data$solver)
ortho = unique(data$ortho)
scalar = unique(data$scalar)
nrhs = unique(data$nrhs)
n_iter = unique(data$n_iter)


#df = subset(data, strtoi(level) == target_level)
#delta = sum(aggregate(tend ~ name, df, sum)$tend) - sum(aggregate(tbegin ~ name, df, sum)$tbegin)
#print(delta)


# computing total durations 
print(min(data$tbegin))
print(max(data$tend))

total_time = max(data$tend) - min(data$tbegin)
#total_time = data[data$name == "Solve"]$tend - data[data$name == "Solve"]$tbegin
#print(total_time)
data = subset(data, strtoi(level) == target_level)
data$duration = data$tend - data$tbegin


data = aggregate(duration ~ name, data, sum)

print(sum(data$duration))
untracked_time = total_time - sum(data$duration)

#print(untracked_time, sum(data$duration), delta, total_time)

data = data %>% add_row(name = "Untracked Time", duration = untracked_time)


data$tt = total_time
data$label = format(format(data$label), width=5, justify="left")

# redefining variables
data$blas = blas
data$solver = solver
data$ortho = ortho
data$scalar = scalar
data$nrhs = nrhs
print(n_iter)
data$n_iter = n_iter

data$label = n_iter
data$x_pos = data$nrhs #paste(data$scalar, data$ortho, sep=" + ")

  return (data)
}



### plot
bar_color_plot = function(data, output, cut=10, tol=1e-8, level=1){



data$id = paste(data$blas, data$ortho, data$solver, data$scalar, data$nrhs)

df = data.frame()
for (i in array(unique(data$id))) {
  df_tmp = bar_color_data(subset(data, id == i), level)
  df_tmp$id = i
  df = rbind(df, df_tmp)
}

#data_s = read.csv(file="../trace_b.csv", sep=",")
#names(data_s) <- c("blas", "solver", "ortho", "position", "n_iter", "t_setup", "t_solve", "re", "scalar", "rr", "nrhs")
#data_s$id = paste(data_s$blas, data_s$ortho, data_s$solver, data_s$scalar, data_s$position)
#data = join(df, data_s, by="id", type="inner")

#data = subset(data, rr <= 1e-8)

data <- df

data <- data %>%
    mutate(y_label = tt) %>%
    mutate(y_label=y_label + .15 * min(cut, max(y_label)))
disp_lim <- cut * 0.99
data$y_label[data$y_label>disp_lim] = disp_lim
print(data)
  g = ggplot(data, aes(x_pos, tt)) +
    geom_col(aes(x_pos, duration, fill=name), width=0.7) +
    #geom_point(aes(x_pos, tt)) +
    geom_text(angle=90, size=4, aes(label=label, y=y_label)) +
    facet_grid( blas ~ solver ) +
    labs(x="Family Number (nrhs = 25)", y="Time (s)") +
    theme_bw() +
    theme(text = element_text(size = 10)) +
    theme(axis.text.x = element_text(angle = 45, hjust = 1)) +
    coord_cartesian(ylim = c(0, cut), expand = TRUE)



ggsave(output, width=20,height=12)

}



data = read.csv(file="trace_t.csv", sep=",", header=FALSE)
names(data) <- c("blas", "scalar", "solver", "ortho", "nrhs", "n_iter", "name", "level", "tbegin", "tend")
bar_color_plot(data, "bar_color.png", cut=10)

#data = read.csv(file="../traces/trace_all_test.csv", sep=",", header=FALSE)
#names(data) <- c("blas", "scalar", "solver", "ortho", "nrhs", "n_iter", "name", "level", "tbegin", "tend")
#bar_color_plot(data, "bar_color_old.png", cut=4)


#+end_src
*** Bar plot
#+begin_src R :tangle test_fabulous_bar.R
library(ggplot2)
library(dplyr)
library(tidyr)
library(stringr)

bar_plot = function(data, output, choice="iter", cut=8, tol=1e-8){

# convergence check
data = subset(data, strtoi(n_iter) > 0)
#data = subset(data, strtoi(rr) < tol * 100)

data$tt = data$t_setup + data$t_solve
data$label = data$n_iter
data$label = format(format(data$label), width=5, justify="left")


data <- data %>% gather(step, t, c("t_setup", "t_solve"), factor_key=TRUE)
data$step = factor(data$step, levels=c("t_setup", "t_solve"))




data <- data %>%
    mutate(y_label = tt) %>%
    mutate(y_label=y_label + .15 * min(cut, max(y_label)))
disp_lim <- cut * 0.99
  data$y_label[data$y_label>disp_lim] = disp_lim

data$x_pos = paste(data$scalar, data$ortho, sep=" + ")



if(choice == "nrhs"){
  data <- data %>% gather(step, val, c("re", "rr"), factor_key=TRUE)
  data$val_r = factor(data$step, levels=c("re", "rr"))
  #print(data)
  data$x_pos = data$nrhs
  data_re = subset(data, val_r == "re")
  data_rr = subset(data, val_r == "rr")
  data_re$Legend = "Relative Error"
  data_rr$Legend = "Relative Residual"
  #data_re$color = "green"
  #data_rr$color = "blue"
  data = rbind(data_re, data_rr)
  data = subset(data, solver != "GCR (m++) (\u221E)")
  g = ggplot(data, aes(x_pos, val, color=Legend)) +
    geom_point() + #, color=val_r)) +
    geom_hline(yintercept=1e-8, linetype="dashed") +
    #scale_fill_manual(name="Legend: ",
    #                  values=c("re"="#4D9900",
    #                           "rr"="#4040FF"),
    #                  labels=c("re"="Relative Error",
    #                           "rr"="Relative Residual")) +
    facet_grid( blas ~ solver ) +
    scale_y_continuous(trans = 'log') +
    labs(x="Number of right hand side : nrhs", y="Relative Error / Relative Residual") +
    theme_bw()

}else if(choice == "re"){
  g = ggplot(data, aes(x_pos, re)) +
    #geom_col(aes(x_pos, re)) +
    geom_point() +
    facet_grid( blas ~ solver ) +
    scale_y_continuous(trans = 'log') +
    labs(x="Right hand side", y="Relative error") +
    theme_bw() +
    theme(text = element_text(size = 10)) +
    theme(axis.text.x = element_text(angle = 45, hjust = 1)) #+
    #coord_cartesian(ylim = c(1e-16, cut), expand = TRUE)

}else if(choice == "rr"){
  g = ggplot(data, aes(x_pos, rr)) +
    geom_point() +
    scale_y_continuous(trans = 'log') +
    facet_grid( blas ~ solver ) +
    labs(x="Configuration (Scalar type / Othogonalisation Scheme)", y="True Relative Residual") +
    theme_bw() +
    theme(text = element_text(size = 10)) +
    theme(axis.text.x = element_text(angle = 45, hjust = 1))

}else{
  g = ggplot(data, aes(x_pos, tt)) +
    geom_col(aes(x_pos, t, fill=step)) +
    geom_text(angle=90, size=4, aes(label=label, y=y_label)) +
    scale_fill_manual(name="Steps: ",
                      values=c("t_setup"="#1f78b4",
                               "t_solve"="#e31a1c"),
                      labels=c("t_setup"="Setup",
                               "t_solve"="Solve")) +
    facet_grid( blas ~ solver ) +
    labs(x="Configuration (Scalar type / Othogonalisation Scheme)", y="Time (s)") +
    theme_bw() +
    theme(text = element_text(size = 10)) +
    theme(axis.text.x = element_text(angle = 45, hjust = 1)) +
    coord_cartesian(ylim = c(0, cut), expand = TRUE)

}

ggsave(output, width=20,height=12)

}


data = read.csv(file="../results_summary.csv")
bar_plot(data, "bar.png")
bar_plot(data, "re.png", choice="re")
bar_plot(data, "rr.png", choice="rr")
bar_plot(data, "precision_per_nrhs.png", choice="nrhs")

#+end_src

*** Convergence history 
#+begin_src R :tangle test_fabulous_cvg.R
library(ggplot2)
library(dplyr)
library(plyr)
library(tidyr)
library(stringr)
library(extrafont)
library(gridExtra)
loadfonts()

# color : orthogonalisation scheme
# shape : real / complex
# linestyle : min / max

colors = c(
  'MGS' = "#4040FF",
  'CGS' = "#4D9900",
  'Tolerance' = "#FF4040"
)

shapes = c(
  'real (double)' = 16,
  'complex (double)' = 22
)

linetypes = c(
  'max' = "solid",
  'min' = "solid"#"dashed"
)


generate_theme = function(
  color_breaks = waiver(),
  shape_breaks = waiver(),
  linetype_breaks = waiver(),
  legend_title = element_blank(),
  legend_rows = 1
  ) {
  return(list(
    scale_color_manual(values = colors, breaks = color_breaks),
    scale_shape_manual(values = shapes, breaks = shape_breaks),
    scale_linetype_manual(values = linetypes, breaks = linetype_breaks),
    guides(
      shape = guide_legend(order = 2, nrow = legend_rows, byrow = TRUE),
      linetype = guide_legend(order = 3, nrow = legend_rows, byrow = TRUE),
      color = guide_legend(order = 1, nrow = legend_rows, byrow = TRUE)
    ),
    theme_bw(),
    theme(
      text = element_text(size = 14),
      legend.title = legend_title,
      legend.position = "bottom",
      legend.background = element_rect(color = "gray40", size = 0.5),
      legend.box = "horizontal",
      legend.key.width = unit(3, "line"),
      axis.text.x = element_text(angle = 60, hjust = 1)
    )
  ))
}

theme_layers = generate_theme()


cvg_plot = function(data, output, choice="iter", cut=1, tol=1e-8, restart_iter=300){

  data <- data %>% gather(Residual, res, c("min", "max"), factor_key=TRUE)
  data$Residual = factor(data$Residual, levels=c("min", "max"))
  data$id = paste(data$blas, data$ortho, data$solver, data$scalar, data$nrhs)
    
  if(choice != "nrhs" && choice != "n"){
    df = subset(data, strtoi(iter) %% 200 == 0)
    max_per_id = join(aggregate(iter ~ id, data, max), data, type="inner")
    max_iter = max(data$iter)
    max_time = max(data$time)
  
    min_per_id <- subset(max_per_id, Residual == "max")
    min_per_id$iter = 0
    min_per_id$time = 0.0

    data_tol <- subset(max_per_id, Residual == "max")
    data_tol$iter = max_iter
    data_tol$time = max_time
    data_tol = rbind(data_tol, min_per_id)
    data_tol$ortho = "Tolerance"
    data_tol$res = tol
    data = rbind(data, data_tol)
    df = rbind(df, max_per_id)

  }
  
  if(choice == "nrhs"){
    max_per_id = join(aggregate(iter ~ id, data, max), data, type="inner")
    #print(aggregate(iter ~ id, data, max))
    data_cvg = subset(max_per_id, res <= 1e-8)
    #data = subset(data, id %in% array(data_cvg$id))
    
    data$nrhs = paste("", data$nrhs)
    print(data$nrhs)
    g = ggplot(data) + 
      geom_line(mapping=aes(iter, res, color = nrhs, linetype = Residual)) +
      #geom_point(data=df, mapping=aes(time, res, color = ortho, shape = scalar, linetype = Residual)) +
      geom_hline(yintercept=1e-8, linetype="dashed") +
      facet_grid( blas ~ solver ) +
      scale_y_continuous(trans = 'log') +
      labs(x="Iterations", y="||R||_2 / ||B||_2") +
      theme_bw()

  } else if(choice == "n"){
    max_per_id = join(aggregate(iter ~ id, data, max), data, type="inner")
    #print(aggregate(iter ~ id, data, max))
    #data_cvg = subset(max_per_id, res <= 1e-8)
    #data = subset(data, id %in% array(data_cvg$id))
    
    data$Family = paste("", data$n + 1)
    #print(data$nrhs)
    g = ggplot(data) + 
      geom_line(mapping=aes(iter, res, color = Family, linetype = Residual)) +
      #geom_point(data=df, mapping=aes(time, res, color = ortho, shape = scalar, linetype = Residual)) +
      #geom_hline(yintercept=tol, linetype="dashed") +
      #facet_grid( blas ~ solver ) +
      facet_grid( . ~ solver ) +
      #ylim(1e-8, 1) +
      scale_y_continuous(trans = 'log') +
      #labs(x="Iterations", y="||R||_2 / ||B||_2") +
      labs(x="Number of Mat Vect Product", y="Residual norm") +
      theme_bw()

  } else if(choice == "time"){
    g = ggplot(data) + 
      geom_line(mapping=aes(time, res, color = ortho, shape = scalar, linetype = Residual)) +
      geom_point(data=df, mapping=aes(time, res, color = ortho, shape = scalar, linetype = Residual)) +
      facet_grid( blas ~ solver ) +
      scale_y_continuous(trans = 'log') +
      labs(x="Time (s)", y="||R||_2 / ||B||_2") +
      coord_cartesian(xlim = c(0, cut), expand = TRUE) +
      theme_layers
  } else {
    df = subset(data, strtoi(iter) %% restart_iter == 0)

    g = ggplot(data) +
      geom_vline(xintercept=seq(restart_iter, 2*restart_iter, restart_iter), linetype="dotted") +
      geom_line(mapping=aes(iter, res, color = ortho, shape = scalar, linetype = Residual)) +
      #geom_point(data=df, mapping=aes(iter, res, color = ortho, shape = scalar, linetype = Residual)) +
      #geom_point(data=df, mapping=aes(iter, res, color = ortho, shape = scalar, linetype = Residual)) +
      facet_grid( blas ~ solver ) +
      scale_y_continuous(trans = 'log') +
      labs(x="Number of sparse mat-vec (mvp)", y="||R||_2 / ||B||_2") +
      theme_layers 
  }
  #ggsave(output, width=4,height=2,dpi=1000)
  ggsave(output, width=14,height=8)

}


data = read.csv(file="../trace_p.csv")
names(data) <- c("blas","scalar","solver","ortho","n","nrhs","iter","min","max","time")
#data = read.csv(file="log.csv")
#data = subset(data, n < 3)#%% 4 == 0
cvg_plot(data, "cvg_iter.png", tol=1e-6, "n")

#data_r = subset(data, scalar == "real (double)")
#data_c = subset(data, scalar == "complex (double)")
#print(data_c)

#cvg_plot(data_r, "cvg_iter_real_nrhs_20.png")
#cvg_plot(data_r, "cvg_time_real_nrhs_20.png", "time")

#cvg_plot(data_c, "cvg_iter_complex_nrhs_20.png")
#cvg_plot(data_c, "cvg_time_complex_nrhs_20.png", "time", cut=2)

#complex (double)
#data = read.csv(file="../csv_backup/results_iter.csv")
#data = filter(data, n == 1)

#data_r = filter(data, scalar == "real (double)")
#cvg_plot(data_r, "cvg_iter_real_nrhs_1.png")
#cvg_plot(data_r, "cvg_time_real_nrhs_1.png", "time", cut=0.1)

#data_c = filter(data, scalar == "complex (double)")
#cvg_plot(data_c, "cvg_iter_complex_nrhs_1.png")
#cvg_plot(data_c, "cvg_time_complex_nrhs_1.png", "time")


#+end_src

